const { deepKebabTransform, jsonApiErrorTransform } = require('./utils/transformers')
const CompeonError = require('./utils/CompeonError')
const compose = require('./utils/compose')
const responses = require('./utils/responses')
const { log, toJsonString } = require('./utils/logging')
const { applyMiddleware } = require('./middleware')

const withErrorHandling = handler => async (...lambdaParams) => {
  try { return await handler(...lambdaParams) || responses.handleEmptyOk() }
  catch (error) { return responses.handleError(error) }
}

const compeonHandler = (handler, middleware = []) => (
  applyMiddleware(...middleware)(withErrorHandling(handler))
)

module.exports = {
  CompeonError,
  compeonHandler,
  log,
  toJsonString,
  responses
}
