const { deepCamelTransform, deepKebabTransform } = require('../utils/transformers')

const DEFAULT_OPTIONS = Object.freeze({
  transformRequest: true,
  transformResponse: true
})

const caseTransformationMiddleware = (options = {}) => next => async lambdaParams => {
  const { transformRequest, transformResponse } = { ...DEFAULT_OPTIONS, ...options }
  const { body } = lambdaParams.event

  if (body && transformRequest) {
    lambdaParams = {
      ...lambdaParams,
      event: {
        ...lambdaParams.event,
        body: deepCamelTransform(body)
      }
    }
  }

  let response = await next(lambdaParams)

  if (response && response.body && transformResponse) {
    response = {
      ...response,
      body: deepKebabTransform(response.body)
    }
  }

  return response
}

module.exports = caseTransformationMiddleware
