const CompeonError = require('../../utils/CompeonError')

describe('CompeonError', () => {
  it('allows setting (message and) status', () => {
    const compeonError = new CompeonError('disappointed', 404)

    expect(compeonError).toHaveProperty('message', 'disappointed')
    expect(compeonError).toHaveProperty('status', 404)
  })

  it('captures stack', () => {
    expect(new CompeonError()).toHaveProperty('stack')
  })

  it('has correct default status and message', () =>{
    const defaultError = new CompeonError()
    expect(defaultError).toHaveProperty('message', '')
    expect(defaultError).toHaveProperty('status', 500)
  })
})
