const compose = require('../../utils/compose')

describe('compose', () => {
  it('calls functions in correct order', () => {
    const composedFunc = compose(
      val => `outer(${val})`,
      val => `middle(${val})`,
      val => `inner(${val})`
    )

    expect(composedFunc('stool')).toEqual('outer(middle(inner(stool)))')
  })

  it('allows empty', () => {
    expect(compose()('stool')).toEqual('stool')
  })

  it('allows promises', async () => {
    const composed = compose(
      async val => val,
      val => val
    )

    const result = composed('stool')

    expect(result).toHaveProperty('then')
    expect(await result).toEqual('stool')
  })
})
