// const compose = (...fns) =>
//   fns.reduce(
//     (f, g) => (...args) => f(g(...args)),
//     val => val
//   )

const compose = (...fns) =>
  fns.reduce(
    (f, g) => (...args) => {
      const value = g(...args)

      if (value && value.then) return value.then(result => f(result))
      else return f(value)
    },
    val => val
  )

module.exports = compose
